#pragma once
#pragma unmanaged

#ifdef RACELOGIC_VBOX_API_DLL_EXPORTS
#define EXPORTED_MEMBER __declspec(dllexport)
#else
#define EXPORTED_MEMBER __declspec(dllimport)
#endif

#include <vector>

namespace RacelogicSetupApiCpp
{
	extern "C" 
	{
		class EXPORTED_MEMBER UnmanagedSampleEventArgs
		{
			std::vector<double> data;
			short satellites;
			bool dgps;
			bool brakeTrigger;
			bool dualAntenna;
			double utcTime;
			double latitude;
			double longitude;
			double speed;
			double heading;
			double height;
			double verticalVelocity;
			double longitudinalAcceleration;
			double lateralAcceleration;
			short glonassSatellites;
			short gpsSatellites;
			short serialNumber;
			int32_t kalmanFilterCode;
			int32_t solutionType;
			double velocityQuality;
			double triggerEventTime;

		public:
			UnmanagedSampleEventArgs(std::vector<double> DataArray, short Satellites,
			bool Dgps, bool BrakeTrigger, bool DualAntenna, double UtcTime,	double Latitude,
			double Longitude, double Speed, double Heading, double Height,
			double VerticalVelocity, double LongitudinalAcceleration, double LateralAcceleration,
			short GlonassSatellites, short GpsSatellites, short SerialNumber,
			int KalmanFilterCode, int SolutionType, double VelocityQuality, double TriggerEventTime);

			~UnmanagedSampleEventArgs();

			std::vector<double> GetData();

			short GetSatellites();

			bool GetDgps();

			bool GetBrakeTrigger();

			bool GetDualAntenna();

			double GetUtcTime();

			double GetLatitude();

			double GetLongitude();

			double GetSpeed();

			double GetHeading();

			double GetHeight();

			double GetVerticalVelocity();

			double GetLongitudinalAcceleration();

			double GetLateralAcceleration();

			short GetGlonassSatellites();

			short GetGpsSatellites();

			short GetSerialNumber();

			int32_t GetKalmanFilterCode();

			int32_t GetSolutionType();

			double GetVelocityQuality();

			double GetTriggerEventTime();
		};
	}
}
